//                              -*- Mode: Verilog -*-
// Filename        : dff_ld.v
// Description     : parameterizable D flip-flop with LD signal
// Author          : Stephen W. Keckler
// Created On      : Mon Oct 16 16:50:50 2006
// Last Modified By: .
// Last Modified On: .
// Update Count    : 0
// Status          : Unknown, Use with caution!

module dff_ld (clk, load, d, y);
   parameter Width = 1;

   input     clk, load;
   input [Width-1:0] d;
   output [Width-1:0] y;

   wire [Width-1:0]   ff_in;

   assign
	 ff_in = load ? d : y;
   
   dff #Width dff0(clk, ff_in, y);

endmodule // DFF

