//                              -*- Mode: Verilog -*-
// Filename        : reg_row.v
// Description     : Register file row - includes feedback multiplexor and flip-flop
// Author          : Stephen W. Keckler
// Created On      : Mon Oct 16 16:52:27 2006
// Last Modified By: .
// Last Modified On: .
// Update Count    : 0
// Status          : Unknown, Use with caution!


module reg_row (clk, write, selW, d, y) ;
   input  clk, write, selW;
   input [15:0] d;
   output [15:0] y;

   wire [15:0] 	 mux_out;
   
   dff #16 row(clk, mux_out, y);

   assign
	 mux_out = (write & selW) ? d : y;
   
endmodule // reg_row
