;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; putc.asm -- LC-2 Character Output
;
; Trap routine to write a character to the console. It services the OUT
;         service call, which is trap vector $21.
;
; Inputs:  R0<7:0> contains the character to write, and R0<15:8> must be 0x00.
; Returns: None
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		.ORIG	$0430		; system call starting address
		ST	R7, SaveR7	; save R7 so we can RET at the bottom
		ST	R1, SaveR1	; R1 will be used to poll the video
					;   hardware
; write the character

TryWrite	LD	R1, DSR	; get status
		LDR	R1, R1, #0
		BRZP	TryWrite	; bit 15 on says video is ready

WriteIt		LD	R1, DDR	; write character
		STR	R0, R1, #0

; return from trap
Return		LD	R1, SaveR1	; restore registers
		LD	R7, SaveR7	; restore jump return R7
		RET			; return from trap

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; data and working space

DSR		.FILL	$FE04		; address of video status register
DDR		.FILL	$FE06		; address of video data register
SaveR1		.FILL	$0000
SaveR7		.FILL	$0000

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		.END
