; startup.asm
; Boot routine that runs as the LC-2 starts up.  Assumes basic service routines
;         have already been loaded (unrealistic).  Does some nice printing
;         and initialization.
; Inputs: none (there can't be any!)
; Returns: none
; On Exit: Halts machine; user restarts when beginning simulation

		.ORIG	$FC00		; where this routine resides
; print strings
		LEA	R0, Title
		PUTSP
		LEA	R0, Copyright
		PUTSP
		LEA	R0, NewLCNote
		PUTSP
		LEA	R0, HardwareRev
		PUTSP
		LEA	R0, OSRev
		PUTSP
		HALT
; could have also jumped to user code, but I want to run the initialization,
; HALT, and then turn off the HALT so that user can start back up easily

; Memory space...
Title		.FILLp	"The LC-3 - A Little Computer"
Copyright	.FILLp	"Copyright (C) Matt Postiff, 1995-2000"
NewLCNote	.FILLp  "LC-3 and 3.5 support added by Stephen W. Keckler and Taylor L. Riche'"	
HardwareRev	.FILLp	"Hardware Revision 6.5 of October, 2003"
OSRev		.FILLp	"LC-3 Operating System Version 6.2"
		.END

; reserve ~128 words for this routine.
