; undeftrap.asm
; Trap service routine for traps that have not been defined.
;         The interrupt vector table ($0000-$00FF) should be initialized to
;         the address of this routine; routines that are installed put their
;         own address into there vector.  Simply prints an error message and
;         halts the machine.
; Inputs: none
; Returns: none
; Context information: Registers are saved.

		.ORIG	$FD00	; load address; default vector table entry
		ST	R7, SaveR7	; save R7 for later return
		ST	R0, SaveR0	; save other registers

; print error string
		LD	R0, ASCIINewLine
		OUT
		LEA	R0, Str1
		PUTSP
		LEA	R0, Str2
		PUTSP

; return from interrupt call
Return		HALT			; halt machine (trap $25)
		LD	R0, SaveR0	; restore R0
		LD	R7, SaveR7	; restore jump return R7
		RET

; Memory space...
ASCIINewLine	.FILL	$000A
Str1		.FILLp	"A trap was executed with an illegal vector number."
Str2		.FILLp  "Machine state should be questioned."
SaveR0		.FILL	$0000
SaveR7		.FILL	$0000
		.END






