/*
  C-code for PLI routines

 */

#include "stdio.h"
#include "acc_user.h"

char *mc_scan_plusargs(char *);

void cmd_arg() {
  static char *filename;
  static s_setval_value value_s = {accStringVal};
  static s_setval_delay delay_s = {{accRealTime},accNoDelay};

  handle reg = acc_handle_tfarg(1);

  filename = mc_scan_plusargs("vhex+");
  if(filename == NULL) {
    io_printf("************************************************************\n");
    io_printf("   Error - null file name.  Please use +vhex+filename \n");
    io_printf("   Example usage: \n      csh> lc35_vsim +vhex+test.vhex +maxc5000\n");
    io_printf("************************************************************\n");
    tf_dofinish();
  }

  value_s.value.str = filename;
  acc_set_value(reg, &value_s, &delay_s);

}

void lc35_putc() {
  
  int print_char = acc_fetch_tfarg_int(1);
  io_printf("%c", (char)print_char);

}


void max_cycles() {
  char* maxc_string;
  int maxc;

  maxc = acc_fetch_tfarg_int(1);
  maxc_string = mc_scan_plusargs("maxc");
  if(maxc_string != NULL) {
    maxc = strtol(maxc_string, NULL, 10);
  }

  tf_putp(0, maxc);
}


void lc35_getc() {
  int ret_char;

  ret_char = getchar();
  tf_putp(0, ret_char);

}
